#Compile Exe
#Include "Win32api.inc"     'Main Windows Include File
#Include "Comdlg32.inc"     'Include file for the Common Dialog Box Library
#Resource "Form5.pbr"       'PowerBASIC resource file
%IDM_OPEN      =    1000    'Equate for File    >> Open...
%IDM_SAVE      =    1002    '                   >> Save...
%IDM_EXIT      =    1004    '                   >> Exit
%IDM_SHOWDLG   =    2000    'Equate for Options >> Show Dialog
%IDM_HELP      =    3000    'Equate for Help    >> Help...          
%IDC_FILENAME  =    4000    'Equate for Control ID of main text box on center of Form
%IDC_EXIT      =    4002    'Equate for Exit Button on Form
%IDC_NAME      =    2100    'Equate for Textbox on Dialog Box


Type WndEventArgs           'Type for passing window procedure parameters.  Allows me
  wParam As Long            'to shorten parameter list.  .NET does this all the time.
  lParam As Long            'See, for example pea for PaintEventArgs in the OnPaint()
  hWnd   As Dword           'Message Handler.
End Type


Function fnWndProc_OnCreate(wea As WndEventArgs) As Long   'Handles WM_CREATE message 
  Local hCtrl As Dword

  'Text Box For Filename or Dialog Box Text
  hCtrl= _
  CreateWindowEx _
  ( _
    %WS_EX_CLIENTEDGE, _     'This gives a text box a nice 3D look
    "Edit", _                'Predefined 'edit' window class
    "", _                    'start out blank
    %WS_CHILD Or %WS_VISIBLE Or %WS_BORDER Or %ES_AUTOHSCROLL, _
    5,20,505,26, _           'edit controls have piles of styles
    Wea.hWnd, _              'parent of edit control, that is main window
    %IDC_FILENAME, _         'equate for control identifier
    GetWindowLong(wea.hWnd,%GWL_HINSTANCE), _
    Byval 0 _                'lpCreateParams -- we're not using any here
  )

  'Exit Button
  hCtrl=_
  CreateWindowEx _
  ( _
    0, _                     'Plain old button will work for me
    "Button", _              'Predefined 'edit' window class
    "Exit", _                'Let's make an exit button
    %WS_CHILD Or %WS_VISIBLE, _     'This works for simple buttons
    205,60,110,26, _                'coordinates & sizes of button
    Wea.hWnd, _                     'Parent of button
    %IDC_Exit, _                    'Equate for button (ctrl id)
    GetWindowLong(wea.hWnd,%GWL_HINSTANCE), _   'Get instance handle
    Byval 0 _                       'No Creation Data
  )

  fnWndProc_OnCreate=0              'Return 0 to Windows
End Function


Sub OnOpen(wea As WndEventArgs)     'Handles File >> Open... From WM_COMMAND
  Local szTitleName As Asciiz*(%MAX_FNAME+%MAX_EXT)
  Local szFileName As Asciiz*%MAX_PATH
  Local szIniDir As Asciiz*256
  Local strFilter As String
  Local ofn As OPENFILENAME
  Local strLine As String

  strFilter= _   'Dynamic strings work best here with PowerBASIC as you can embed NULLs.
  "bas files (*.bas), inc files (*.inc), rc files (*.rc)"+Chr$(0)+"*.bas;*.inc;*.rc"+Chr$(0)+ _
  "c files (*.c), cpp files (*.cpp), h files (*.h)"+Chr$(0)+"*.c;*.cpp;*.h"+Chr$(0)+ _
  "txt files (*.txt)"+Chr$(0)+"*.txt"+Chr$(0)+Chr$(0)
  szIniDir=CurDir$                                     'Initial directory
  ofn.lStructSize=SizeOf(OPENFILENAME)                 'Size of structure/type
  ofn.hWndOwner=Wea.hWnd                               'Owned by Main Program Window
  ofn.hInstance=GetWindowLong(wea.hWnd,%GWL_HINSTANCE) 'The instance handle can be gotten many ways
  ofn.lpstrFilter=StrPtr(strFilter)                    'Filters file extensions shown in dialog box
  ofn.nMaxFile=%MAX_PATH                                
  ofn.nMaxFileTitle=%MAX_FNAME+%MAX_EXT
  ofn.lpstrInitialDir = VarPtr(szIniDir)
  ofn.lpstrDefExt=%NULL
  ofn.Flags=%OFN_HIDEREADONLY Or %OFN_CREATEPROMPT
  ofn.lpstrFile=VarPtr(szFileName)                     'This is finally the file name string you want
  ofn.lpstrFileTitle=VarPtr(szTitleName)               'This is as above, but without the full path
  ofn.lpstrTitle=%NULL
  If GetOpenFileName(ofn) Then                         'Function returns non-zero if valid file chosen
     Call SetWindowText(GetDlgItem(Wea.hWnd,%IDC_FILENAME),szFileName)
  Else
     MsgBox("You Must Have Cancelled!")
  End If
End Sub


Sub OnSave(wea As WndEventArgs)                         'Handles File >> Save... From WM_COMMAND
  MsgBox("You Clicked File >> Save...")
End Sub


Sub OnExit(wea As WndEventArgs)                         'Handles File >> Exit From WM_COMMAND
  MsgBox("Send A Message To Windows To Close The Application.")
  Call SendMessage(wea.hWnd,%WM_CLOSE,0,0)
End Sub


Function ModalDlgProc(ByVal hwndDlg As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Local szLocalBuffer As Asciiz*80
  Local hwndEdit As Dword

  Select Case As Long wMsg
    Case %WM_INITDIALOG
      hwndEdit=GetDlgItem(hwndDlg,%IDC_NAME)
      Call SetFocus(hwndEdit)                                 'Set focus to text box when
      Function=%FALSE                                         'dialog box opens
    Case %WM_COMMAND
      Select Case Lowrd(wParam)
        Case %IDOK
          hwndEdit=GetDlgItem(hwndDlg,%IDC_NAME)              'GetDlgItem() is a really useful function that plays
          Call GetWindowText(hwndEdit,szLocalBuffer,80)       'a big part in allowing you to eliminate globals
          Call SetWindowText _
          ( _
            GetDlgItem(GetParent(hwndDlg),%IDC_FILENAME), _   'Get parent of dialog box, then
            szLocalBuffer _                                   'control id of text box on main
          )                                                   'form into which to place text.
          Call EndDialog(hwndDlg,%TRUE)                       'EndDialog() ends the dialog box.  If %TRUE is
          Function=%TRUE                                      'returned the user hit the [ENTER] button or clicked
          Exit Function                                       'OK.  If the user cancels or x's out return %FALSE
        Case %IDCANCEL                                        'as the 2nd parameter of EndDialog().
          Call EndDialog(hwndDlg,%FALSE)
          Function=%TRUE
          Exit Function
      End Select
  End Select

  Function=%FALSE
End Function


Sub OnShowDialog(wea As WndEventArgs)
  If DialogBox(GetWindowLong(wea.hWnd,%GWL_HINSTANCE),"dlgBox",wea.hWnd,CodePtr(ModalDlgProc)) Then
     MsgBox _                                                     'DialogBox() is the function that
     ( _                                                          'causes a dialog box to be shown.
       "You Clicked The 'OK' Button Or Pressed The [ENTER] Key!" _'The Function takes four parameters.
     )                                                            'The first (retrieved here by 
  Else                                                            'GetWindowLong() Is the program 
     MsgBox _                                                     'instance handle.  The second Is
     ( _                                                          'the String which names the Dialog 
       "You Cancelled Out!" _                                     'Box In Form5.rc. The third is the
     )                                                            'parent window handle, and the 
  End If                                                          'fourth is a Pointer To the Dialog 
End Sub                                                           'Box procedure.


Sub OnHelp(wea As WndEventArgs)
  MsgBox("There Is No Help!")
End Sub


Function fnWndProc_OnCommand(wea As WndEventArgs) As Long     'Handles WM_COMMAND message
  Select Case LoWrd(wea.wParam)
    Case %IDM_OPEN
      Call OnOpen(wea)
    Case %IDM_SAVE
      Call OnSave(wea)
    Case %IDM_EXIT
      Call OnExit(wea)
    Case %IDC_EXIT
      Call OnExit(wea)
    Case %IDM_SHOWDLG
      Call OnShowDialog(wea)
    Case %IDM_HELP
      Call OnHelp(wea)
  End Select

  fnWndProc_OnCommand=0
End Function


Function fnWndProc_OnClose(wea As WndEventArgs) As Long       'Handles WM_CLOSE message
  MsgBox _
  ( _
    "fnWndProc_OnClose() Is A Good Place To Prompt User If Changes" & Chr$(13) & Chr$(10) & _
    "Should Be Saved And To Clean Stuff Up." _
  )
  Call DestroyWindow(wea.hWnd)

  fnWndProc_OnClose=0
End Function


Function fnWndProc_OnDestroy(wea As WndEventArgs) As Long     'Handles WM_DESTROY message
  Call PostQuitMessage(0)
  fnWndProc_OnDestroy=0
End Function


Function fnWndProc(ByVal hWnd As Long,ByVal wMsg As Long,ByVal wParam As Long,ByVal lParam As Long) As Long
  Local wea As WndEventArgs

  Select Case wMsg
    Case %WM_CREATE
      wea.wParam=wParam: wea.lParam=lParam: wea.hWnd=hWnd
      fnWndProc=fnWndProc_OnCreate(wea)
      Exit Function
    Case %WM_COMMAND
      wea.wParam=wParam: wea.lParam=lParam: wea.hWnd=hWnd
      fnWndProc=fnWndProc_OnCommand(wea)
      Exit Function
    Case %WM_CLOSE
      wea.wParam=wParam: wea.lParam=lParam: wea.hWnd=hWnd
      fnWndProc=fnWndProc_OnClose(wea)
      Exit Function
    Case %WM_DESTROY
      wea.wParam=wParam: wea.lParam=lParam: wea.hWnd=hWnd
      fnWndProc=fnWndProc_OnDestroy(wea)
      Exit Function
  End Select

  fnWndProc=DefWindowProc(hWnd,wMsg,wParam,lParam)
End Function


Function WinMain(ByVal hIns As Long, ByVal hPrev As Long, ByVal lpCmdLn As Asciiz Ptr, ByVal iShow As Long) As Long
  Local winclass As WndClassEx
  Local szAppName As Asciiz*8
  Local hMainWnd As Dword
  Local Msg As tagMsg

  szAppName="Form5"                                       : winclass.cbSize=SizeOf(winclass)
  winclass.lpszClassName=VarPtr(szAppName)                : winclass.lpfnWndProc=CodePtr(fnWndProc)
  winclass.style=%CS_HREDRAW Or %CS_VREDRAW               : winclass.hInstance=hIns
  winclass.cbClsExtra=0                                   : winclass.cbWndExtra=0
  winclass.hIcon=LoadIcon(%NULL, ByVal %IDI_APPLICATION)  : winclass.hCursor=LoadCursor(%NULL, ByVal %IDC_ARROW)
  winclass.hbrBackground=%COLOR_BTNFACE+1                 : winclass.lpszMenuName=VarPtr(szAppName)
  Call RegisterClassEx(winclass)
  hMainWnd=CreateWindowEx(0,szAppName,"Form5",%WS_OVERLAPPEDWINDOW,350,300,525,155,0,0,hIns,ByVal 0)
  Call ShowWindow(hMainWnd,iShow)
  Call UpdateWindow(hMainWnd)
  While GetMessage(Msg,%NULL,0,0)
    Call TranslateMessage(Msg)
    Call DispatchMessage(Msg)
  Wend

  Function=msg.wParam
End Function
